require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_CPUFUNC_H_)) {
    eval 'sub _MACHINE_CPUFUNC_H_ () {1;}' unless defined(&_MACHINE_CPUFUNC_H_);
    if(defined(&_KERNEL)) {
	require 'sys/cdefs.ph';
	require 'sys/types.ph';
	require 'machine/specialreg.ph';
	eval 'sub invlpg {
	    my($addr) = @_;
    	    eval q({  &__asm  &__volatile(\\"invlpg (%0)\\" : : \\"r\\" ($addr) : \\"memory\\"); } );
	}' unless defined(&invlpg);
	eval 'sub lidt {
	    my($p) = @_;
    	    eval q({  &__asm  &__volatile(\\"lidt (%0)\\" : : \\"r\\" ($p) : \\"memory\\"); });
	}' unless defined(&lidt);
	eval 'sub lldt {
	    my($sel) = @_;
    	    eval q({  &__asm  &__volatile(\\"lldt %0\\" : : \\"r\\" ($sel)); });
	}' unless defined(&lldt);
	eval 'sub ltr {
	    my($sel) = @_;
    	    eval q({  &__asm  &__volatile(\\"ltr %0\\" : : \\"r\\" ($sel)); });
	}' unless defined(&ltr);
	eval 'sub lcr0 {
	    my($val) = @_;
    	    eval q({  &__asm  &__volatile(\\"movl %0,%%cr0\\" : : \\"r\\" ($val)); });
	}' unless defined(&lcr0);
	eval 'sub rcr0 {
	    my($void) = @_;
    	    eval q({ \'u_int\'  &val;  &__asm  &__volatile(\\"movl %%cr0,%0\\" : \\"=r\\" ( &val));  &val; });
	}' unless defined(&rcr0);
	eval 'sub rcr2 {
	    my($void) = @_;
    	    eval q({ \'u_int\'  &val;  &__asm  &__volatile(\\"movl %%cr2,%0\\" : \\"=r\\" ( &val));  &val; });
	}' unless defined(&rcr2);
	eval 'sub lcr3 {
	    my($val) = @_;
    	    eval q({  &__asm  &__volatile(\\"movl %0,%%cr3\\" : : \\"r\\" ($val)); });
	}' unless defined(&lcr3);
	eval 'sub rcr3 {
	    my($void) = @_;
    	    eval q({ \'u_int\'  &val;  &__asm  &__volatile(\\"movl %%cr3,%0\\" : \\"=r\\" ( &val));  &val; });
	}' unless defined(&rcr3);
	eval 'sub lcr4 {
	    my($val) = @_;
    	    eval q({  &__asm  &__volatile(\\"movl %0,%%cr4\\" : : \\"r\\" ($val)); });
	}' unless defined(&lcr4);
	eval 'sub rcr4 {
	    my($void) = @_;
    	    eval q({ \'u_int\'  &val;  &__asm  &__volatile(\\"movl %%cr4,%0\\" : \\"=r\\" ( &val));  &val; });
	}' unless defined(&rcr4);
	eval 'sub tlbflush {
	    my($void) = @_;
    	    eval q({ \'u_int\'  &val;  &__asm  &__volatile(\\"movl %%cr3,%0\\" : \\"=r\\" ( &val));  &__asm  &__volatile(\\"movl %0,%%cr3\\" : : \\"r\\" ( &val)); });
	}' unless defined(&tlbflush);
	eval 'sub tlbflushg {
	    my($void) = @_;
    	    eval q({  &if ( &cpu_feature &  &CPUID_PGE) { \'u_int\'  &cr4 =  &rcr4();  &lcr4( &cr4 & ~ &CR4_PGE);  &lcr4( &cr4); }  &else  &tlbflush(); });
	}' unless defined(&tlbflushg);
	if(defined(&notyet)) {
	}
	eval 'sub enable_intr {
	    my($void) = @_;
    	    eval q({  &__asm  &__volatile(\\"sti\\"); });
	}' unless defined(&enable_intr);
	eval 'sub read_eflags {
	    my($void) = @_;
    	    eval q({ \'u_int\'  &ef;  &__asm  &__volatile(\\"pushfl; popl %0\\" : \\"=r\\" ( &ef)); ( &ef); });
	}' unless defined(&read_eflags);
	eval 'sub write_eflags {
	    my($ef) = @_;
    	    eval q({  &__asm  &__volatile(\\"pushl %0; popfl\\" : : \\"r\\" ($ef)); });
	}' unless defined(&write_eflags);
	eval 'sub wbinvd {
	    my($void) = @_;
    	    eval q({  &__asm  &__volatile(\\"wbinvd\\"); });
	}' unless defined(&wbinvd);
	eval 'sub clflush {
	    my($addr) = @_;
    	    eval q({  &__asm  &__volatile(\\"clflush %0\\" : \\"+m\\" ($addr)); });
	}' unless defined(&clflush);
	eval 'sub mfence {
	    my($void) = @_;
    	    eval q({  &__asm  &__volatile(\\"mfence\\" : : : \\"memory\\"); });
	}' unless defined(&mfence);
	eval 'sub wrmsr {
	    my($msr,$newval) = @_;
    	    eval q({  &__asm  &__volatile(\\"wrmsr\\" : : \\"A\\" ($newval), \\"c\\" ($msr)); });
	}' unless defined(&wrmsr);
	eval 'sub rdmsr {
	    my($msr) = @_;
    	    eval q({  &u_int64_t  &rv;  &__asm  &__volatile(\\"rdmsr\\" : \\"=A\\" ( &rv) : \\"c\\" ($msr)); ( &rv); });
	}' unless defined(&rdmsr);
	eval 'sub OPTERON_MSR_PASSCODE () {0x9c5a203a;}' unless defined(&OPTERON_MSR_PASSCODE);
	eval 'sub wrmsr_locked {
	    my($msr,$code,$newval) = @_;
    	    eval q({  &__asm  &volatile(\\"wrmsr\\" : : \\"A\\" ($newval), \\"c\\" ($msr), \\"D\\" ($code)); });
	}' unless defined(&wrmsr_locked);
	eval 'sub read_psl () {
	    eval q( &read_eflags());
	}' unless defined(&read_psl);
	eval 'sub write_psl {
	    my($x) = @_;
    	    eval q( &write_eflags($x));
	}' unless defined(&write_psl);
    }
}
1;
